searchNodes=[{"doc":"Library that adds Matrix Application Service functionalities to Phoenix applications. Installation Add this library to your dependencies in mix.exs defp deps do # ..., { :matrix_app_service , &quot;~&gt; 0.1.0&quot; } end Usage Write adapters Create one or multiple modules that implement the following modules: MatrixAppService.Adapter.Room , MatrixAppService.Adapter.User , MatrixAppService.Adapter.Transaction . For instance: @behaviour MatrixAppService.Adapter.Room @impl MatrixAppService.Adapter.Room def query_alias ( room_alias ) do # Do something with the room alias # If the room exists, return :ok end @behaviour MatrixAppService.Adapter.User @impl MatrixAppService.Adapter.User def query_user ( user_id ) do # Do something with the user ID # If the user exists, return :ok end @behaviour MatrixAppService.Adapter.Transaction @impl MatrixAppService.Adapter.Transaction def new_event ( % MatrixAppService.Event { type : type , content : content } ) do # Do something with the event end Configure Option 1: Using the :matrix_app_service supervision tree Configuration: config :matrix_app_service , internal_supervisor : true , transaction_adapter : App.Matrix.Transaction , room_adapter : App.Matrix.Room , user_adapter : App.Matrix.User , path : &quot;/matrix&quot; base_url : &quot;http://synapse:8008&quot; , access_token : &quot;access token&quot; , homeserver_token : &quot;homeserver token&quot; Option 2: Using the :matrix_app_service endpoint in your own supervision tree In your application module: children = [ # ..., { MatrixAppServiceWeb.Endpoint , app_service_config ( ) } ] # ... defp app_service_config ( ) , do : Application . get_env ( :app , :app_service ) Configuration: config :app , :app_service , transaction_adapter : App.Matrix.Transaction , room_adapter : App.Matrix.Room , user_adapter : App.Matrix.User , path : &quot;/matrix&quot; base_url : &quot;http://synapse:8008&quot; , access_token : &quot;access token&quot; , homeserver_token : &quot;homeserver token&quot; Option 3: Using your own endpoint In your Phoenix Router: use MatrixAppServiceWeb.Routes MatrixAppServiceWeb.Routes . routes ( Application . get_env ( :app , :app_service ) ) Configuration: config :app , :app_service , transaction_adapter : App.Matrix.Transaction , room_adapter : App.Matrix.Room , user_adapter : App.Matrix.User , path : &quot;/matrix&quot; base_url : &quot;http://synapse:8008&quot; , access_token : &quot;access token&quot; , homeserver_token : &quot;homeserver token&quot; Use the Client-Server API You can use the functions in MatrixAppService.Client","ref":"MatrixAppService.html","title":"MatrixAppService","type":"module"},{"doc":"Behaviour for a module that handles rooms reserved by the application service.","ref":"MatrixAppService.Adapter.Room.html","title":"MatrixAppService.Adapter.Room","type":"behaviour"},{"doc":"Responds to a room query by alias. If the room exists, implementations should create the room (for instance by using MatrixAppService.Client.create_room/1 ) then return :ok . If the room doesn't exist, they should return anything else.","ref":"MatrixAppService.Adapter.Room.html#c:query_alias/1","title":"MatrixAppService.Adapter.Room.query_alias/1","type":"callback"},{"doc":"Behaviour for a module that handles transactions involving registered users and rooms.","ref":"MatrixAppService.Adapter.Transaction.html","title":"MatrixAppService.Adapter.Transaction","type":"behaviour"},{"doc":"Called when the application service receives an event.","ref":"MatrixAppService.Adapter.Transaction.html#c:new_event/1","title":"MatrixAppService.Adapter.Transaction.new_event/1","type":"callback"},{"doc":"Behaviour for a module that handles rooms reserved by the application service.","ref":"MatrixAppService.Adapter.User.html","title":"MatrixAppService.Adapter.User","type":"behaviour"},{"doc":"Responds to a user query by Matrix ID. If the user exists, implementations should create the user (for instance by using MatrixAppService.Client.register/2 ) then return :ok . If the user doesn't exist, they should return anything else.","ref":"MatrixAppService.Adapter.User.html#c:query_user/1","title":"MatrixAppService.Adapter.User.query_user/1","type":"callback"},{"doc":"This module is used when the library uses its own repo.","ref":"MatrixAppService.Bridge.html","title":"MatrixAppService.Bridge","type":"module"},{"doc":"Returns an %Ecto.Changeset{} for tracking event changes. Examples iex&gt; change_event ( event ) % Ecto.Changeset { data : % Event { } }","ref":"MatrixAppService.Bridge.html#change_event/2","title":"MatrixAppService.Bridge.change_event/2","type":"function"},{"doc":"Returns an %Ecto.Changeset{} for tracking room changes. Examples iex&gt; change_room ( room ) % Ecto.Changeset { data : % Room { } }","ref":"MatrixAppService.Bridge.html#change_room/2","title":"MatrixAppService.Bridge.change_room/2","type":"function"},{"doc":"Returns an %Ecto.Changeset{} for tracking user changes. Examples iex&gt; change_user ( user ) % Ecto.Changeset { data : % User { } }","ref":"MatrixAppService.Bridge.html#change_user/2","title":"MatrixAppService.Bridge.change_user/2","type":"function"},{"doc":"Creates an event. Examples iex&gt; create_event ( %{ field : value } ) { :ok , % Event { } } iex&gt; create_event ( %{ field : bad_value } ) { :error , % Ecto.Changeset { } }","ref":"MatrixAppService.Bridge.html#create_event/1","title":"MatrixAppService.Bridge.create_event/1","type":"function"},{"doc":"Creates a room. Examples iex&gt; create_room ( %{ field : value } ) { :ok , % Room { } } iex&gt; create_room ( %{ field : bad_value } ) { :error , % Ecto.Changeset { } }","ref":"MatrixAppService.Bridge.html#create_room/1","title":"MatrixAppService.Bridge.create_room/1","type":"function"},{"doc":"Creates a user. Examples iex&gt; create_user ( %{ field : value } ) { :ok , % User { } } iex&gt; create_user ( %{ field : bad_value } ) { :error , % Ecto.Changeset { } }","ref":"MatrixAppService.Bridge.html#create_user/1","title":"MatrixAppService.Bridge.create_user/1","type":"function"},{"doc":"Deletes an event. Examples iex&gt; delete_event ( event ) { :ok , % Event { } } iex&gt; delete_event ( event ) { :error , % Ecto.Changeset { } }","ref":"MatrixAppService.Bridge.html#delete_event/1","title":"MatrixAppService.Bridge.delete_event/1","type":"function"},{"doc":"Deletes a room. Examples iex&gt; delete_room ( room ) { :ok , % Room { } } iex&gt; delete_room ( room ) { :error , % Ecto.Changeset { } }","ref":"MatrixAppService.Bridge.html#delete_room/1","title":"MatrixAppService.Bridge.delete_room/1","type":"function"},{"doc":"Deletes a user. Examples iex&gt; delete_user ( user ) { :ok , % User { } } iex&gt; delete_user ( user ) { :error , % Ecto.Changeset { } }","ref":"MatrixAppService.Bridge.html#delete_user/1","title":"MatrixAppService.Bridge.delete_user/1","type":"function"},{"doc":"Gets a single event. Raises Ecto.NoResultsError if the Event does not exist. Examples iex&gt; get_event! ( 123 ) % Event { } iex&gt; get_event! ( 456 ) ** (Ecto.NoResultsError)","ref":"MatrixAppService.Bridge.html#get_event!/1","title":"MatrixAppService.Bridge.get_event!/1","type":"function"},{"doc":"","ref":"MatrixAppService.Bridge.html#get_event_by_local_id/1","title":"MatrixAppService.Bridge.get_event_by_local_id/1","type":"function"},{"doc":"","ref":"MatrixAppService.Bridge.html#get_event_by_remote_id/1","title":"MatrixAppService.Bridge.get_event_by_remote_id/1","type":"function"},{"doc":"","ref":"MatrixAppService.Bridge.html#get_events_by_local_id/1","title":"MatrixAppService.Bridge.get_events_by_local_id/1","type":"function"},{"doc":"","ref":"MatrixAppService.Bridge.html#get_events_by_remote_id/1","title":"MatrixAppService.Bridge.get_events_by_remote_id/1","type":"function"},{"doc":"","ref":"MatrixAppService.Bridge.html#get_last_event_in_room/1","title":"MatrixAppService.Bridge.get_last_event_in_room/1","type":"function"},{"doc":"Gets a single room. Raises Ecto.NoResultsError if the Room does not exist. Examples iex&gt; get_room! ( 123 ) % Room { } iex&gt; get_room! ( 456 ) ** (Ecto.NoResultsError)","ref":"MatrixAppService.Bridge.html#get_room!/1","title":"MatrixAppService.Bridge.get_room!/1","type":"function"},{"doc":"","ref":"MatrixAppService.Bridge.html#get_room_by_local_id/1","title":"MatrixAppService.Bridge.get_room_by_local_id/1","type":"function"},{"doc":"","ref":"MatrixAppService.Bridge.html#get_room_by_remote_id/1","title":"MatrixAppService.Bridge.get_room_by_remote_id/1","type":"function"},{"doc":"Gets a single user. Raises Ecto.NoResultsError if the User does not exist. Examples iex&gt; get_user! ( 123 ) % User { } iex&gt; get_user! ( 456 ) ** (Ecto.NoResultsError)","ref":"MatrixAppService.Bridge.html#get_user!/1","title":"MatrixAppService.Bridge.get_user!/1","type":"function"},{"doc":"","ref":"MatrixAppService.Bridge.html#get_user_by_local_id/1","title":"MatrixAppService.Bridge.get_user_by_local_id/1","type":"function"},{"doc":"","ref":"MatrixAppService.Bridge.html#get_user_by_remote_id/1","title":"MatrixAppService.Bridge.get_user_by_remote_id/1","type":"function"},{"doc":"Returns the list of events. Examples iex&gt; list_events ( ) [ % Event { } , ... ]","ref":"MatrixAppService.Bridge.html#list_events/0","title":"MatrixAppService.Bridge.list_events/0","type":"function"},{"doc":"Returns the list of rooms. Examples iex&gt; list_rooms ( ) [ % Room { } , ... ]","ref":"MatrixAppService.Bridge.html#list_rooms/0","title":"MatrixAppService.Bridge.list_rooms/0","type":"function"},{"doc":"Returns the list of users. Examples iex&gt; list_users ( ) [ % User { } , ... ]","ref":"MatrixAppService.Bridge.html#list_users/0","title":"MatrixAppService.Bridge.list_users/0","type":"function"},{"doc":"Updates an event. Examples iex&gt; update_event ( event , %{ field : new_value } ) { :ok , % Event { } } iex&gt; update_event ( event , %{ field : bad_value } ) { :error , % Ecto.Changeset { } }","ref":"MatrixAppService.Bridge.html#update_event/2","title":"MatrixAppService.Bridge.update_event/2","type":"function"},{"doc":"Updates a room. Examples iex&gt; update_room ( room , %{ field : new_value } ) { :ok , % Room { } } iex&gt; update_room ( room , %{ field : bad_value } ) { :error , % Ecto.Changeset { } }","ref":"MatrixAppService.Bridge.html#update_room/2","title":"MatrixAppService.Bridge.update_room/2","type":"function"},{"doc":"Updates a user. Examples iex&gt; update_user ( user , %{ field : new_value } ) { :ok , % User { } } iex&gt; update_user ( user , %{ field : bad_value } ) { :error , % Ecto.Changeset { } }","ref":"MatrixAppService.Bridge.html#update_user/2","title":"MatrixAppService.Bridge.update_user/2","type":"function"},{"doc":"","ref":"MatrixAppService.Bridge.html#upsert_user/2","title":"MatrixAppService.Bridge.upsert_user/2","type":"function"},{"doc":"Schema and helpers for keeping track of events sent through the bridge.","ref":"MatrixAppService.Bridge.Event.html","title":"MatrixAppService.Bridge.Event","type":"module"},{"doc":"Schema and helpers for keeping track of room correspondence.","ref":"MatrixAppService.Bridge.Room.html","title":"MatrixAppService.Bridge.Room","type":"module"},{"doc":"Schema and helpers for keeping track of user correspondence.","ref":"MatrixAppService.Bridge.User.html","title":"MatrixAppService.Bridge.User","type":"module"},{"doc":"The Bridge config.","ref":"MatrixAppService.BridgeConfig.html","title":"MatrixAppService.BridgeConfig","type":"module"},{"doc":"","ref":"MatrixAppService.BridgeConfig.html#event_functions/0","title":"MatrixAppService.BridgeConfig.event_functions/0","type":"macro"},{"doc":"","ref":"MatrixAppService.BridgeConfig.html#room_functions/0","title":"MatrixAppService.BridgeConfig.room_functions/0","type":"macro"},{"doc":"","ref":"MatrixAppService.BridgeConfig.html#user_functions/0","title":"MatrixAppService.BridgeConfig.user_functions/0","type":"macro"},{"doc":"Convenience wrapper around Polyjuice.Client.LowLevel . Library users can use the wrapped functions or call user/1 and pass the returned struct to Polyjuice functions.","ref":"MatrixAppService.Client.html","title":"MatrixAppService.Client","type":"module"},{"doc":"Return a client for the application service. By default, the client gets its homeserver URL and access token from configuration. Different options can be provided to override the defaults, those are: :base_url : homerver URL :acces_token : access token :device_id : device ID :user_id : user ID :storage : a Polyjuice.Client.Storage.t/0","ref":"MatrixAppService.Client.html#client/1","title":"MatrixAppService.Client.client/1","type":"function"},{"doc":"Create a new alias for a Matrix room. Arguments: room_id : room ID room_alias : room alias client_options : see client/1 (optional)","ref":"MatrixAppService.Client.html#create_alias/3","title":"MatrixAppService.Client.create_alias/3","type":"function"},{"doc":"Create a Matrix room. Arguments: options : see Polyjuice.Client.Room.create_room/2 client_options : see client/1 (optional)","ref":"MatrixAppService.Client.html#create_room/2","title":"MatrixAppService.Client.create_room/2","type":"function"},{"doc":"Get room ID and additional information, given a room's alias Arguments: room_alias : the alias to look for client_options : see client/1 (optional)","ref":"MatrixAppService.Client.html#get_alias/2","title":"MatrixAppService.Client.get_alias/2","type":"function"},{"doc":"Get the data on an account. Arguments: user_id : the ID of the user whose profile should be retrieved. If ommited, it defaults to the user_id represented by the client event_type : the type of event queried client_options : see client/1 (optional)","ref":"MatrixAppService.Client.html#get_data/3","title":"MatrixAppService.Client.get_data/3","type":"function"},{"doc":"Get user profile. Arguments: user_id : the ID of the user whose profile should be retrieved. If ommited, it defaults to the user_id represented by the client client_options : see client/1 (optional)","ref":"MatrixAppService.Client.html#get_profile/2","title":"MatrixAppService.Client.get_profile/2","type":"function"},{"doc":"Get a state event from a room. Arguments: room_id : the ID of the user whose profile should be retrieved. If ommited, it defaults to the user_id represented by the client. event_type : the type of event state_key : the event state key client_options : see client/1 (optional) If event_type is not provided, returns a list of events. If event_type and state_key are provided, returns an event content. state_key can be omitted but this will return events that have a blank state key, not events that have &quot;any state key&quot;.","ref":"MatrixAppService.Client.html#get_state/4","title":"MatrixAppService.Client.get_state/4","type":"function"},{"doc":"Join a room. Arguments: room_id : the room ID client_options : see client/1 (optional)","ref":"MatrixAppService.Client.html#join/2","title":"MatrixAppService.Client.join/2","type":"function"},{"doc":"Modify avatar url for the user. Arguments: user_id : the ID of the user whose profile should be retrieved. If ommited, it defaults to the user_id represented by the client avatar_url : an mxc: URL specifying the location of the new profile client_options : see client/1 (optional)","ref":"MatrixAppService.Client.html#put_avatar_url/3","title":"MatrixAppService.Client.put_avatar_url/3","type":"function"},{"doc":"Put the data on an account. Arguments: user_id : the ID of the user whose profile should be retrieved. If ommited, it defaults to the user_id represented by the client event_type : the type of event queried data : the new data client_options : see client/1 (optional)","ref":"MatrixAppService.Client.html#put_data/4","title":"MatrixAppService.Client.put_data/4","type":"function"},{"doc":"Modify display name for the user. Arguments: user_id : the ID of the user whose profile should be retrieved. If ommited, it defaults to the user_id represented by the client displayname : the new displayname client_options : see client/1 (optional)","ref":"MatrixAppService.Client.html#put_displayname/3","title":"MatrixAppService.Client.put_displayname/3","type":"function"},{"doc":"Send a redact event to a room. Arguments: room_id : the ID of the user whose profile should be retrieved. If ommited, it defaults to the user_id represented by the client. event : the redact event reason : the reason (optional) client_options : see client/1 (optional)","ref":"MatrixAppService.Client.html#redact_message/4","title":"MatrixAppService.Client.redact_message/4","type":"function"},{"doc":"Register a new Matrix user. Arguments: options : a keyword list that can contain these keys: :inhibit_login : true :device_id : device ID, defaults to &quot;APP_SERVICE&quot; :initial_device_display_name : device name, defaults to &quot;ApplicationService&quot; :kind : kind of account to register, defaults to &quot;user&quot; , can also be &quot;guest&quot; client_options : see client/1 (optional)","ref":"MatrixAppService.Client.html#register/2","title":"MatrixAppService.Client.register/2","type":"function"},{"doc":"Search a Matrix user in the User Directory. Arguments: search_term : the search term for the user limit : a search limit number, defaults to false (unlimited) client_options : see client/1 (optional)","ref":"MatrixAppService.Client.html#search_user/3","title":"MatrixAppService.Client.search_user/3","type":"function"},{"doc":"Send a message to a Matrix room. Arguments: room_id : room ID msg : see Polyjuice.Client.Room.send_message/3 client_options : see client/1 (optional)","ref":"MatrixAppService.Client.html#send_message/3","title":"MatrixAppService.Client.send_message/3","type":"function"},{"doc":"Send a state event to a room. Arguments: room_id : the ID of the user whose profile should be retrieved. If ommited, it defaults to the user_id represented by the client. event_type : the type of event state_key : the event state key event_content : the event content client_options : see client/1 (optional)","ref":"MatrixAppService.Client.html#send_state_event/5","title":"MatrixAppService.Client.send_state_event/5","type":"function"},{"doc":"Upload a file to the media repository. Arguments: data : Polyjuice.Client.Media.upload/3 options : Polyjuice.Client.Media.upload/3 client_options : see client/1 (optional)","ref":"MatrixAppService.Client.html#upload/3","title":"MatrixAppService.Client.upload/3","type":"function"},{"doc":"","ref":"MatrixAppService.Client.html#t:client_options/0","title":"MatrixAppService.Client.client_options/0","type":"type"},{"doc":"","ref":"MatrixAppService.Client.html#t:create_options/0","title":"MatrixAppService.Client.create_options/0","type":"type"},{"doc":"Behaviour defining callbacks implemented in MatrixAppService.Client . Can be used to mock the client, for instance with mox : TODO: example","ref":"MatrixAppService.ClientBehaviour.html","title":"MatrixAppService.ClientBehaviour","type":"behaviour"},{"doc":"","ref":"MatrixAppService.ClientBehaviour.html#c:client/0","title":"MatrixAppService.ClientBehaviour.client/0","type":"callback"},{"doc":"","ref":"MatrixAppService.ClientBehaviour.html#c:client/1","title":"MatrixAppService.ClientBehaviour.client/1","type":"callback"},{"doc":"","ref":"MatrixAppService.ClientBehaviour.html#c:create_alias/3","title":"MatrixAppService.ClientBehaviour.create_alias/3","type":"callback"},{"doc":"","ref":"MatrixAppService.ClientBehaviour.html#c:create_attachment_message/3","title":"MatrixAppService.ClientBehaviour.create_attachment_message/3","type":"callback"},{"doc":"","ref":"MatrixAppService.ClientBehaviour.html#c:create_room/1","title":"MatrixAppService.ClientBehaviour.create_room/1","type":"callback"},{"doc":"","ref":"MatrixAppService.ClientBehaviour.html#c:create_room/2","title":"MatrixAppService.ClientBehaviour.create_room/2","type":"callback"},{"doc":"","ref":"MatrixAppService.ClientBehaviour.html#c:get_alias/1","title":"MatrixAppService.ClientBehaviour.get_alias/1","type":"callback"},{"doc":"","ref":"MatrixAppService.ClientBehaviour.html#c:get_alias/2","title":"MatrixAppService.ClientBehaviour.get_alias/2","type":"callback"},{"doc":"","ref":"MatrixAppService.ClientBehaviour.html#c:get_data/2","title":"MatrixAppService.ClientBehaviour.get_data/2","type":"callback"},{"doc":"","ref":"MatrixAppService.ClientBehaviour.html#c:get_data/3","title":"MatrixAppService.ClientBehaviour.get_data/3","type":"callback"},{"doc":"","ref":"MatrixAppService.ClientBehaviour.html#c:get_profile/1","title":"MatrixAppService.ClientBehaviour.get_profile/1","type":"callback"},{"doc":"","ref":"MatrixAppService.ClientBehaviour.html#c:get_profile/2","title":"MatrixAppService.ClientBehaviour.get_profile/2","type":"callback"},{"doc":"","ref":"MatrixAppService.ClientBehaviour.html#c:get_state/3","title":"MatrixAppService.ClientBehaviour.get_state/3","type":"callback"},{"doc":"","ref":"MatrixAppService.ClientBehaviour.html#c:get_state/4","title":"MatrixAppService.ClientBehaviour.get_state/4","type":"callback"},{"doc":"","ref":"MatrixAppService.ClientBehaviour.html#c:join/1","title":"MatrixAppService.ClientBehaviour.join/1","type":"callback"},{"doc":"","ref":"MatrixAppService.ClientBehaviour.html#c:join/2","title":"MatrixAppService.ClientBehaviour.join/2","type":"callback"},{"doc":"","ref":"MatrixAppService.ClientBehaviour.html#c:put_avatar_url/2","title":"MatrixAppService.ClientBehaviour.put_avatar_url/2","type":"callback"},{"doc":"","ref":"MatrixAppService.ClientBehaviour.html#c:put_avatar_url/3","title":"MatrixAppService.ClientBehaviour.put_avatar_url/3","type":"callback"},{"doc":"","ref":"MatrixAppService.ClientBehaviour.html#c:put_data/3","title":"MatrixAppService.ClientBehaviour.put_data/3","type":"callback"},{"doc":"","ref":"MatrixAppService.ClientBehaviour.html#c:put_data/4","title":"MatrixAppService.ClientBehaviour.put_data/4","type":"callback"},{"doc":"","ref":"MatrixAppService.ClientBehaviour.html#c:put_displayname/2","title":"MatrixAppService.ClientBehaviour.put_displayname/2","type":"callback"},{"doc":"","ref":"MatrixAppService.ClientBehaviour.html#c:put_displayname/3","title":"MatrixAppService.ClientBehaviour.put_displayname/3","type":"callback"},{"doc":"","ref":"MatrixAppService.ClientBehaviour.html#c:redact_message/3","title":"MatrixAppService.ClientBehaviour.redact_message/3","type":"callback"},{"doc":"","ref":"MatrixAppService.ClientBehaviour.html#c:redact_message/4","title":"MatrixAppService.ClientBehaviour.redact_message/4","type":"callback"},{"doc":"","ref":"MatrixAppService.ClientBehaviour.html#c:register/0","title":"MatrixAppService.ClientBehaviour.register/0","type":"callback"},{"doc":"","ref":"MatrixAppService.ClientBehaviour.html#c:register/1","title":"MatrixAppService.ClientBehaviour.register/1","type":"callback"},{"doc":"","ref":"MatrixAppService.ClientBehaviour.html#c:register/2","title":"MatrixAppService.ClientBehaviour.register/2","type":"callback"},{"doc":"","ref":"MatrixAppService.ClientBehaviour.html#c:search_user/2","title":"MatrixAppService.ClientBehaviour.search_user/2","type":"callback"},{"doc":"","ref":"MatrixAppService.ClientBehaviour.html#c:search_user/3","title":"MatrixAppService.ClientBehaviour.search_user/3","type":"callback"},{"doc":"","ref":"MatrixAppService.ClientBehaviour.html#c:send_message/2","title":"MatrixAppService.ClientBehaviour.send_message/2","type":"callback"},{"doc":"","ref":"MatrixAppService.ClientBehaviour.html#c:send_message/3","title":"MatrixAppService.ClientBehaviour.send_message/3","type":"callback"},{"doc":"","ref":"MatrixAppService.ClientBehaviour.html#c:send_state_event/4","title":"MatrixAppService.ClientBehaviour.send_state_event/4","type":"callback"},{"doc":"","ref":"MatrixAppService.ClientBehaviour.html#c:send_state_event/5","title":"MatrixAppService.ClientBehaviour.send_state_event/5","type":"callback"},{"doc":"","ref":"MatrixAppService.ClientBehaviour.html#c:upload/2","title":"MatrixAppService.ClientBehaviour.upload/2","type":"callback"},{"doc":"","ref":"MatrixAppService.ClientBehaviour.html#c:upload/3","title":"MatrixAppService.ClientBehaviour.upload/3","type":"callback"},{"doc":"","ref":"MatrixAppService.ClientBehaviour.html#t:client_options/0","title":"MatrixAppService.ClientBehaviour.client_options/0","type":"type"},{"doc":"","ref":"MatrixAppService.ClientBehaviour.html#t:create_options/0","title":"MatrixAppService.ClientBehaviour.create_options/0","type":"type"},{"doc":"","ref":"MatrixAppService.ClientBehaviour.html#t:data_format/0","title":"MatrixAppService.ClientBehaviour.data_format/0","type":"type"},{"doc":"Ecto schema for a Matrix event.","ref":"MatrixAppService.Event.html","title":"MatrixAppService.Event","type":"module"},{"doc":"","ref":"MatrixAppService.Event.html#new/1","title":"MatrixAppService.Event.new/1","type":"function"},{"doc":"Module containing migrations for tables used in bridge mode. Should be used like this: TODO: example","ref":"MatrixAppService.Migrations.html","title":"MatrixAppService.Migrations","type":"module"},{"doc":"","ref":"MatrixAppService.Migrations.html#change/0","title":"MatrixAppService.Migrations.change/0","type":"function"},{"doc":"","ref":"MatrixAppService.Migrations.html#create_events/0","title":"MatrixAppService.Migrations.create_events/0","type":"function"},{"doc":"","ref":"MatrixAppService.Migrations.html#create_events_table/0","title":"MatrixAppService.Migrations.create_events_table/0","type":"function"},{"doc":"","ref":"MatrixAppService.Migrations.html#create_rooms/0","title":"MatrixAppService.Migrations.create_rooms/0","type":"function"},{"doc":"","ref":"MatrixAppService.Migrations.html#create_users/0","title":"MatrixAppService.Migrations.create_users/0","type":"function"},{"doc":"","ref":"MatrixAppService.Migrations.html#migrate/0","title":"MatrixAppService.Migrations.migrate/0","type":"function"},{"doc":"","ref":"MatrixAppService.Migrations.html#remove_indexes_uniqueness/0","title":"MatrixAppService.Migrations.remove_indexes_uniqueness/0","type":"function"},{"doc":"","ref":"MatrixAppService.Repo.html","title":"MatrixAppService.Repo","type":"module"},{"doc":"Callback implementation for Ecto.Repo.aggregate/3 .","ref":"MatrixAppService.Repo.html#aggregate/3","title":"MatrixAppService.Repo.aggregate/3","type":"function"},{"doc":"Callback implementation for Ecto.Repo.aggregate/4 .","ref":"MatrixAppService.Repo.html#aggregate/4","title":"MatrixAppService.Repo.aggregate/4","type":"function"},{"doc":"Callback implementation for Ecto.Repo.all/2 .","ref":"MatrixAppService.Repo.html#all/2","title":"MatrixAppService.Repo.all/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.checked_out?/0 .","ref":"MatrixAppService.Repo.html#checked_out?/0","title":"MatrixAppService.Repo.checked_out?/0","type":"function"},{"doc":"Callback implementation for Ecto.Repo.checkout/2 .","ref":"MatrixAppService.Repo.html#checkout/2","title":"MatrixAppService.Repo.checkout/2","type":"function"},{"doc":"","ref":"MatrixAppService.Repo.html#child_spec/1","title":"MatrixAppService.Repo.child_spec/1","type":"function"},{"doc":"Callback implementation for Ecto.Repo.config/0 .","ref":"MatrixAppService.Repo.html#config/0","title":"MatrixAppService.Repo.config/0","type":"function"},{"doc":"Callback implementation for Ecto.Repo.default_options/1 .","ref":"MatrixAppService.Repo.html#default_options/1","title":"MatrixAppService.Repo.default_options/1","type":"function"},{"doc":"Callback implementation for Ecto.Repo.delete/2 .","ref":"MatrixAppService.Repo.html#delete/2","title":"MatrixAppService.Repo.delete/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.delete!/2 .","ref":"MatrixAppService.Repo.html#delete!/2","title":"MatrixAppService.Repo.delete!/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.delete_all/2 .","ref":"MatrixAppService.Repo.html#delete_all/2","title":"MatrixAppService.Repo.delete_all/2","type":"function"},{"doc":"A convenience function for SQL-based repositories that forces all connections in the pool to disconnect within the given interval. See Ecto.Adapters.SQL.disconnect_all/3 for more information.","ref":"MatrixAppService.Repo.html#disconnect_all/2","title":"MatrixAppService.Repo.disconnect_all/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.exists?/2 .","ref":"MatrixAppService.Repo.html#exists?/2","title":"MatrixAppService.Repo.exists?/2","type":"function"},{"doc":"A convenience function for SQL-based repositories that executes an EXPLAIN statement or similar depending on the adapter to obtain statistics for the given query. See Ecto.Adapters.SQL.explain/4 for more information.","ref":"MatrixAppService.Repo.html#explain/3","title":"MatrixAppService.Repo.explain/3","type":"function"},{"doc":"Callback implementation for Ecto.Repo.get/3 .","ref":"MatrixAppService.Repo.html#get/3","title":"MatrixAppService.Repo.get/3","type":"function"},{"doc":"Callback implementation for Ecto.Repo.get!/3 .","ref":"MatrixAppService.Repo.html#get!/3","title":"MatrixAppService.Repo.get!/3","type":"function"},{"doc":"Callback implementation for Ecto.Repo.get_by/3 .","ref":"MatrixAppService.Repo.html#get_by/3","title":"MatrixAppService.Repo.get_by/3","type":"function"},{"doc":"Callback implementation for Ecto.Repo.get_by!/3 .","ref":"MatrixAppService.Repo.html#get_by!/3","title":"MatrixAppService.Repo.get_by!/3","type":"function"},{"doc":"Callback implementation for Ecto.Repo.get_dynamic_repo/0 .","ref":"MatrixAppService.Repo.html#get_dynamic_repo/0","title":"MatrixAppService.Repo.get_dynamic_repo/0","type":"function"},{"doc":"Callback implementation for Ecto.Repo.in_transaction?/0 .","ref":"MatrixAppService.Repo.html#in_transaction?/0","title":"MatrixAppService.Repo.in_transaction?/0","type":"function"},{"doc":"Callback implementation for Ecto.Repo.insert/2 .","ref":"MatrixAppService.Repo.html#insert/2","title":"MatrixAppService.Repo.insert/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.insert!/2 .","ref":"MatrixAppService.Repo.html#insert!/2","title":"MatrixAppService.Repo.insert!/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.insert_all/3 .","ref":"MatrixAppService.Repo.html#insert_all/3","title":"MatrixAppService.Repo.insert_all/3","type":"function"},{"doc":"Callback implementation for Ecto.Repo.insert_or_update/2 .","ref":"MatrixAppService.Repo.html#insert_or_update/2","title":"MatrixAppService.Repo.insert_or_update/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.insert_or_update!/2 .","ref":"MatrixAppService.Repo.html#insert_or_update!/2","title":"MatrixAppService.Repo.insert_or_update!/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.load/2 .","ref":"MatrixAppService.Repo.html#load/2","title":"MatrixAppService.Repo.load/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.one/2 .","ref":"MatrixAppService.Repo.html#one/2","title":"MatrixAppService.Repo.one/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.one!/2 .","ref":"MatrixAppService.Repo.html#one!/2","title":"MatrixAppService.Repo.one!/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.preload/3 .","ref":"MatrixAppService.Repo.html#preload/3","title":"MatrixAppService.Repo.preload/3","type":"function"},{"doc":"Callback implementation for Ecto.Repo.prepare_query/3 .","ref":"MatrixAppService.Repo.html#prepare_query/3","title":"MatrixAppService.Repo.prepare_query/3","type":"function"},{"doc":"Callback implementation for Ecto.Repo.put_dynamic_repo/1 .","ref":"MatrixAppService.Repo.html#put_dynamic_repo/1","title":"MatrixAppService.Repo.put_dynamic_repo/1","type":"function"},{"doc":"A convenience function for SQL-based repositories that executes the given query. See Ecto.Adapters.SQL.query/4 for more information.","ref":"MatrixAppService.Repo.html#query/3","title":"MatrixAppService.Repo.query/3","type":"function"},{"doc":"A convenience function for SQL-based repositories that executes the given query. See Ecto.Adapters.SQL.query!/4 for more information.","ref":"MatrixAppService.Repo.html#query!/3","title":"MatrixAppService.Repo.query!/3","type":"function"},{"doc":"A convenience function for SQL-based repositories that executes the given multi-result query. See Ecto.Adapters.SQL.query_many/4 for more information.","ref":"MatrixAppService.Repo.html#query_many/3","title":"MatrixAppService.Repo.query_many/3","type":"function"},{"doc":"A convenience function for SQL-based repositories that executes the given multi-result query. See Ecto.Adapters.SQL.query_many!/4 for more information.","ref":"MatrixAppService.Repo.html#query_many!/3","title":"MatrixAppService.Repo.query_many!/3","type":"function"},{"doc":"Callback implementation for Ecto.Repo.reload/2 .","ref":"MatrixAppService.Repo.html#reload/2","title":"MatrixAppService.Repo.reload/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.reload!/2 .","ref":"MatrixAppService.Repo.html#reload!/2","title":"MatrixAppService.Repo.reload!/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.rollback/1 .","ref":"MatrixAppService.Repo.html#rollback/1","title":"MatrixAppService.Repo.rollback/1","type":"function"},{"doc":"Callback implementation for Ecto.Repo.start_link/1 .","ref":"MatrixAppService.Repo.html#start_link/1","title":"MatrixAppService.Repo.start_link/1","type":"function"},{"doc":"Callback implementation for Ecto.Repo.stop/1 .","ref":"MatrixAppService.Repo.html#stop/1","title":"MatrixAppService.Repo.stop/1","type":"function"},{"doc":"Callback implementation for Ecto.Repo.stream/2 .","ref":"MatrixAppService.Repo.html#stream/2","title":"MatrixAppService.Repo.stream/2","type":"function"},{"doc":"A convenience function for SQL-based repositories that translates the given query to SQL. See Ecto.Adapters.SQL.to_sql/3 for more information.","ref":"MatrixAppService.Repo.html#to_sql/2","title":"MatrixAppService.Repo.to_sql/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.transaction/2 .","ref":"MatrixAppService.Repo.html#transaction/2","title":"MatrixAppService.Repo.transaction/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.update/2 .","ref":"MatrixAppService.Repo.html#update/2","title":"MatrixAppService.Repo.update/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.update!/2 .","ref":"MatrixAppService.Repo.html#update!/2","title":"MatrixAppService.Repo.update!/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.update_all/3 .","ref":"MatrixAppService.Repo.html#update_all/3","title":"MatrixAppService.Repo.update_all/3","type":"function"},{"doc":"Implements the Application Service authorization as a Plug. https://matrix.org/docs/spec/application_service/r0.1.2#authorization","ref":"MatrixAppServiceWeb.AuthPlug.html","title":"MatrixAppServiceWeb.AuthPlug","type":"module"},{"doc":"","ref":"MatrixAppServiceWeb.Endpoint.html","title":"MatrixAppServiceWeb.Endpoint","type":"module"},{"doc":"Callback implementation for Phoenix.Endpoint.broadcast/3 .","ref":"MatrixAppServiceWeb.Endpoint.html#broadcast/3","title":"MatrixAppServiceWeb.Endpoint.broadcast/3","type":"function"},{"doc":"Callback implementation for Phoenix.Endpoint.broadcast!/3 .","ref":"MatrixAppServiceWeb.Endpoint.html#broadcast!/3","title":"MatrixAppServiceWeb.Endpoint.broadcast!/3","type":"function"},{"doc":"Callback implementation for Phoenix.Endpoint.broadcast_from/4 .","ref":"MatrixAppServiceWeb.Endpoint.html#broadcast_from/4","title":"MatrixAppServiceWeb.Endpoint.broadcast_from/4","type":"function"},{"doc":"Callback implementation for Phoenix.Endpoint.broadcast_from!/4 .","ref":"MatrixAppServiceWeb.Endpoint.html#broadcast_from!/4","title":"MatrixAppServiceWeb.Endpoint.broadcast_from!/4","type":"function"},{"doc":"Callback implementation for Plug.call/2 .","ref":"MatrixAppServiceWeb.Endpoint.html#call/2","title":"MatrixAppServiceWeb.Endpoint.call/2","type":"function"},{"doc":"Returns the child specification to start the endpoint under a supervision tree.","ref":"MatrixAppServiceWeb.Endpoint.html#child_spec/1","title":"MatrixAppServiceWeb.Endpoint.child_spec/1","type":"function"},{"doc":"Returns the endpoint configuration for key Returns default if the key does not exist.","ref":"MatrixAppServiceWeb.Endpoint.html#config/2","title":"MatrixAppServiceWeb.Endpoint.config/2","type":"function"},{"doc":"Reloads the configuration given the application environment changes.","ref":"MatrixAppServiceWeb.Endpoint.html#config_change/2","title":"MatrixAppServiceWeb.Endpoint.config_change/2","type":"function"},{"doc":"Returns the host for the given endpoint.","ref":"MatrixAppServiceWeb.Endpoint.html#host/0","title":"MatrixAppServiceWeb.Endpoint.host/0","type":"function"},{"doc":"Callback implementation for Plug.init/1 .","ref":"MatrixAppServiceWeb.Endpoint.html#init/1","title":"MatrixAppServiceWeb.Endpoint.init/1","type":"function"},{"doc":"Callback implementation for Phoenix.Endpoint.local_broadcast/3 .","ref":"MatrixAppServiceWeb.Endpoint.html#local_broadcast/3","title":"MatrixAppServiceWeb.Endpoint.local_broadcast/3","type":"function"},{"doc":"Callback implementation for Phoenix.Endpoint.local_broadcast_from/4 .","ref":"MatrixAppServiceWeb.Endpoint.html#local_broadcast_from/4","title":"MatrixAppServiceWeb.Endpoint.local_broadcast_from/4","type":"function"},{"doc":"Generates the path information when routing to this endpoint.","ref":"MatrixAppServiceWeb.Endpoint.html#path/1","title":"MatrixAppServiceWeb.Endpoint.path/1","type":"function"},{"doc":"Generates the script name.","ref":"MatrixAppServiceWeb.Endpoint.html#script_name/0","title":"MatrixAppServiceWeb.Endpoint.script_name/0","type":"function"},{"doc":"Starts the endpoint supervision tree. All other options are merged into the endpoint configuration.","ref":"MatrixAppServiceWeb.Endpoint.html#start_link/1","title":"MatrixAppServiceWeb.Endpoint.start_link/1","type":"function"},{"doc":"Generates a base64-encoded cryptographic hash (sha512) to a static file in priv/static . Meant to be used for Subresource Integrity with CDNs.","ref":"MatrixAppServiceWeb.Endpoint.html#static_integrity/1","title":"MatrixAppServiceWeb.Endpoint.static_integrity/1","type":"function"},{"doc":"Returns a two item tuple with the first item being the static_path and the second item being the static_integrity .","ref":"MatrixAppServiceWeb.Endpoint.html#static_lookup/1","title":"MatrixAppServiceWeb.Endpoint.static_lookup/1","type":"function"},{"doc":"Generates a route to a static file in priv/static .","ref":"MatrixAppServiceWeb.Endpoint.html#static_path/1","title":"MatrixAppServiceWeb.Endpoint.static_path/1","type":"function"},{"doc":"Generates the static URL without any path information. It uses the configuration under :static_url to generate such. It falls back to :url if :static_url is not set.","ref":"MatrixAppServiceWeb.Endpoint.html#static_url/0","title":"MatrixAppServiceWeb.Endpoint.static_url/0","type":"function"},{"doc":"Generates the endpoint base URL but as a URI struct. It uses the configuration under :url to generate such. Useful for manipulating the URL data and passing it to URL helpers.","ref":"MatrixAppServiceWeb.Endpoint.html#struct_url/0","title":"MatrixAppServiceWeb.Endpoint.struct_url/0","type":"function"},{"doc":"Callback implementation for Phoenix.Endpoint.subscribe/2 .","ref":"MatrixAppServiceWeb.Endpoint.html#subscribe/2","title":"MatrixAppServiceWeb.Endpoint.subscribe/2","type":"function"},{"doc":"Callback implementation for Phoenix.Endpoint.unsubscribe/1 .","ref":"MatrixAppServiceWeb.Endpoint.html#unsubscribe/1","title":"MatrixAppServiceWeb.Endpoint.unsubscribe/1","type":"function"},{"doc":"Generates the endpoint base URL without any path information. It uses the configuration under :url to generate such.","ref":"MatrixAppServiceWeb.Endpoint.html#url/0","title":"MatrixAppServiceWeb.Endpoint.url/0","type":"function"},{"doc":"Conveniences for translating and building error messages.","ref":"MatrixAppServiceWeb.ErrorHelpers.html","title":"MatrixAppServiceWeb.ErrorHelpers","type":"module"},{"doc":"Translates an error message.","ref":"MatrixAppServiceWeb.ErrorHelpers.html#translate_error/1","title":"MatrixAppServiceWeb.ErrorHelpers.translate_error/1","type":"function"},{"doc":"JSON views for errors.","ref":"MatrixAppServiceWeb.ErrorView.html","title":"MatrixAppServiceWeb.ErrorView","type":"module"},{"doc":"JSON view for a 403 response status.","ref":"MatrixAppServiceWeb.ErrorView.html#render/2","title":"MatrixAppServiceWeb.ErrorView.render/2","type":"function"},{"doc":"","ref":"MatrixAppServiceWeb.Router.html","title":"MatrixAppServiceWeb.Router","type":"module"},{"doc":"Callback invoked by Plug on every request.","ref":"MatrixAppServiceWeb.Router.html#call/2","title":"MatrixAppServiceWeb.Router.call/2","type":"function"},{"doc":"Callback required by Plug that initializes the router for serving web requests.","ref":"MatrixAppServiceWeb.Router.html#init/1","title":"MatrixAppServiceWeb.Router.init/1","type":"function"},{"doc":"","ref":"MatrixAppServiceWeb.Router.html#matrix_app_service/2","title":"MatrixAppServiceWeb.Router.matrix_app_service/2","type":"function"},{"doc":"Provides the Matrix Application Service API routes. https://matrix.org/docs/spec/application_service/r0.1.2","ref":"MatrixAppServiceWeb.Routes.html","title":"MatrixAppServiceWeb.Routes","type":"module"},{"doc":"","ref":"MatrixAppServiceWeb.Routes.html#__using__/1","title":"MatrixAppServiceWeb.Routes.__using__/1","type":"macro"},{"doc":"This macro injects the API routes in a Phoenix router.","ref":"MatrixAppServiceWeb.Routes.html#routes/1","title":"MatrixAppServiceWeb.Routes.routes/1","type":"macro"},{"doc":"This plug allows to set compile time configuration as private conn parameters.","ref":"MatrixAppServiceWeb.SetConfigPlug.html","title":"MatrixAppServiceWeb.SetConfigPlug","type":"module"},{"doc":"Controller for rooms.","ref":"MatrixAppServiceWeb.V1.RoomController.html","title":"MatrixAppServiceWeb.V1.RoomController","type":"module"},{"doc":"https://matrix.org/docs/spec/application_service/r0.1.2#get-matrix-app-v1-rooms-roomalias","ref":"MatrixAppServiceWeb.V1.RoomController.html#query/2","title":"MatrixAppServiceWeb.V1.RoomController.query/2","type":"function"},{"doc":"","ref":"MatrixAppServiceWeb.V1.ThirdPartyController.html","title":"MatrixAppServiceWeb.V1.ThirdPartyController","type":"module"},{"doc":"","ref":"MatrixAppServiceWeb.V1.ThirdPartyController.html#show/2","title":"MatrixAppServiceWeb.V1.ThirdPartyController.show/2","type":"function"},{"doc":"Controller for transactions.","ref":"MatrixAppServiceWeb.V1.TransactionController.html","title":"MatrixAppServiceWeb.V1.TransactionController","type":"module"},{"doc":"https://matrix.org/docs/spec/application_service/r0.1.2#put-matrix-app-v1-transactions-txnid","ref":"MatrixAppServiceWeb.V1.TransactionController.html#push/2","title":"MatrixAppServiceWeb.V1.TransactionController.push/2","type":"function"},{"doc":"Controller for users.","ref":"MatrixAppServiceWeb.V1.UserController.html","title":"MatrixAppServiceWeb.V1.UserController","type":"module"},{"doc":"https://matrix.org/docs/spec/application_service/r0.1.2#get-matrix-app-v1-users-userid","ref":"MatrixAppServiceWeb.V1.UserController.html#query/2","title":"MatrixAppServiceWeb.V1.UserController.query/2","type":"function"}]